import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkSiteImgs, ThinkSiteImgsParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkSiteImgs(params: ThinkSiteImgsParam) {
  const res = await request.get<ApiResult<PageResult<ThinkSiteImgs>>>(
    THINK_API_URL + '/think/think-site-imgs/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkSiteImgs(params?: ThinkSiteImgsParam) {
  const res = await request.get<ApiResult<ThinkSiteImgs[]>>(
    THINK_API_URL + '/think/think-site-imgs',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkSiteImgs(data: ThinkSiteImgs) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-imgs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkSiteImgs(data: ThinkSiteImgs) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-imgs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkSiteImgs(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-imgs/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkSiteImgs(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-site-imgs/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkSiteImgs(id: number) {
  const res = await request.get<ApiResult<ThinkSiteImgs>>(
    THINK_API_URL + '/think/think-site-imgs/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
